Index: .cvsignore
===================================================================
--- .cvsignore	(revision 470)
+++ .cvsignore	(revision 470)
@@ -0,0 +1,3 @@
+.project
+.cvsignore
+.pydevproject
Index: MpdlXmlTextServer.py
===================================================================
--- MpdlXmlTextServer.py	(revision 451)
+++ MpdlXmlTextServer.py	(revision 482)
@@ -1,14 +1,55 @@
-
 from OFS.SimpleItem import SimpleItem
 from Products.PageTemplates.PageTemplateFile import PageTemplateFile 
+
 from Ft.Xml import EMPTY_NAMESPACE, Parse
 from Ft.Xml.Domlette import NonvalidatingReader
-
-import md5
-import sys
+import Ft.Xml.Domlette
+import cStringIO
+
+import xml.etree.ElementTree as ET
+
+import re
 import logging
 import urllib
-import documentViewer
-from documentViewer import getTextFromNode, serializeNode
+
+from SrvTxtUtils import getInt, getText, getHttpData
+
+def serialize(node):
+    """returns a string containing an XML snippet of node"""
+    s = ET.tostring(node, 'UTF-8')
+    # snip off XML declaration
+    if s.startswith('<?xml'):
+        i = s.find('?>')
+        return s[i+3:]
+
+    return s
+
+
+def getTextFromNode(node):
+    """get the cdata content of a node"""
+    if node is None:
+        return ""
+
+    # 4Suite:
+    nodelist=node.childNodes
+    text = ""
+    for n in nodelist:
+        if n.nodeType == node.TEXT_NODE:
+           text = text + n.data
+    
+    return text
+
+def serializeNode(node, encoding="utf-8"):
+    """returns a string containing node as XML"""
+    #s = ET.tostring(node)
+    
+    # 4Suite:
+    stream = cStringIO.StringIO()
+    Ft.Xml.Domlette.Print(node, stream=stream, encoding=encoding)
+    s = stream.getvalue()
+    stream.close()
+
+    return s
+
 
 class MpdlXmlTextServer(SimpleItem):
@@ -22,7 +63,5 @@
     manage_changeMpdlXmlTextServerForm = PageTemplateFile("zpt/manage_changeMpdlXmlTextServer", globals())
         
-    def __init__(self,id,title="",serverUrl="http://mpdl-test.mpiwg-berlin.mpg.de/mpdl/interface/", serverName=None, timeout=40):
-    #def __init__(self,id,title="",serverUrl="http://mpdl-text.mpiwg-berlin.mpg.de:30030/mpdl/interface/", serverName=None, timeout=40):    
-        
+    def __init__(self,id,title="",serverUrl="http://mpdl-text.mpiwg-berlin.mpg.de/mpdl/interface/", serverName=None, timeout=40):
         """constructor"""
         self.id=id
@@ -36,22 +75,20 @@
     def getHttpData(self, url, data=None):
         """returns result from url+data HTTP request"""
-        return documentViewer.getHttpData(url,data,timeout=self.timeout)
+        return getHttpData(url,data,timeout=self.timeout)
     
     def getServerData(self, method, data=None):
         """returns result from text server for method+data"""
         url = self.serverUrl+method
-        return documentViewer.getHttpData(url,data,timeout=self.timeout)
-
+        return getHttpData(url,data,timeout=self.timeout)
+
+    # WTF: what does this really do? can it be integrated in getPage?
     def getSearch(self, pageinfo=None,  docinfo=None):
         """get search list"""
+        logging.debug("getSearch()")
         docpath = docinfo['textURLPath'] 
         url = docinfo['url']
         pagesize = pageinfo['queryPageSize']
         pn = pageinfo.get('searchPN',1)
-        #sn = pageinfo['sn']
-        s = pageinfo['s']
-        highlightElementPos =pageinfo ['highlightElementPos']
-        highlightElement = pageinfo ['highlightElement']
-        
+        sn = pageinfo.get('sn',None) #TODO: is this s now?
         highlightQuery = pageinfo['highlightQuery']
         query =pageinfo['query']
@@ -63,6 +100,5 @@
         tocPN = pageinfo['tocPN']
         selfurl = self.absolute_url()
-        data = self.getServerData("doc-query.xql","document=%s&mode=%s&queryType=%s&query=%s&queryResultPageSize=%s&queryResultPN=%s&s=%s&viewMode=%s&characterNormalization=%s&highlightElementPos=%s&highlightElement=%s&highlightQuery=%s"%(docpath, 'text', queryType, urllib.quote(query), pagesize, pn, s, viewMode,characterNormalization, highlightElementPos, highlightElement, urllib.quote(highlightQuery)))
-        #data = self.getServerData("doc-query.xql","document=%s&mode=%s&queryType=%s&query=%s&queryResultPageSize=%s&queryResultPN=%s&sn=%s&viewMode=%s&characterNormalization=%s&highlightQuery=%s"%(docpath, 'text', queryType, urllib.quote(query), pagesize, pn, sn, viewMode,characterNormalization, urllib.quote(highlightQuery)))
+        data = self.getServerData("doc-query.xql","document=%s&mode=%s&queryType=%s&query=%s&queryResultPageSize=%s&queryResultPN=%s&sn=%s&viewMode=%s&characterNormalization=%s&highlightQuery=%s"%(docpath, 'text', queryType, urllib.quote(query), pagesize, pn, sn, viewMode,characterNormalization, urllib.quote(highlightQuery)))
         pagexml = data.replace('?document=%s'%str(docpath),'?url=%s'%url)
         pagedom = Parse(pagexml)
@@ -112,5 +148,5 @@
                             hrefNode.nodeValue = href.replace('../lt/lemma.xql','%s/template/head_main_query'%(selfurl))        
                             l.setAttributeNS(None, 'target', '_blank')
-                            l.setAttributeNS(None, 'onClick',"popupWin = window.open(this.href, 'contacts', 'location,width=300,height=400,top=180, left=400, scrollbars=1'); return false;")
+                            l.setAttributeNS(None, 'onClick',"popupWin = window.open(this.href, 'contacts', 'location,width=500,height=600,top=180, left=400, scrollbars=1'); return false;")
                             l.setAttributeNS(None, 'onDblclick', 'popupWin.focus();')  
                 pagedivs = pagedom.xpath("//div[@class='queryResultMorphExpansion']")                
@@ -134,5 +170,5 @@
                             hrefNode.nodeValue = href.replace('../lt/lemma.xql','%s/template/head_main_lemma'%(selfurl))        
                             l.setAttributeNS(None, 'target', '_blank')
-                            l.setAttributeNS(None, 'onClick',"popupWin = window.open(this.href, 'contacts', 'location,width=300,height=400,top=180, left=400, scrollbars=1'); return false;")
+                            l.setAttributeNS(None, 'onClick',"popupWin = window.open(this.href, 'contacts', 'location,width=500,height=600,top=180, left=400, scrollbars=1'); return false;")
                             l.setAttributeNS(None, 'onDblclick', 'popupWin.focus();')
                 return serializeNode(pagenode)      
@@ -146,16 +182,14 @@
             return None
 
-        url = docinfo['url']
-        selfurl = self.absolute_url()
         pn = pageinfo['current']
         hrefList=[]
         myList= ""
         text=self.getServerData("xpath.xql", "document=%s&xpath=%s&pn=%s"%(docinfo['textURLPath'],xpath,pn))
-        dom = Parse(text)
-        result = dom.xpath("//result/resultPage/place")
+        dom = ET.fromstring(text)
+        result = dom.findall(".//result/resultPage/place")
         for l in result:
-            hrefNode= l.getAttributeNodeNS(None, u"id")
-            href= hrefNode.nodeValue
+            href = l.get("id")
             hrefList.append(href)
+            # WTF: what does this do?
             myList = ",".join(hrefList)
         #logging.debug("getGisPlaces :%s"%(myList))                             
@@ -165,261 +199,207 @@
         """Show all Gis Places of whole Book """
         xpath ='//echo:place'
-        docpath =docinfo['textURLPath']
-        url = docinfo['url']
-        selfurl =self.absolute_url()
-        pn =pageinfo['current']
         hrefList=[]
         myList=""
         text=self.getServerData("xpath.xql", "document=%s&xpath=%s"%(docinfo['textURLPath'],xpath))
-        dom =Parse(text)
-        result = dom.xpath("//result/resultPage/place")
+        dom = ET.fromstring(text)
+        result = dom.findall(".//result/resultPage/place")
         
         for l in result:
-            hrefNode = l.getAttributeNodeNS(None, u"id")
-            href= hrefNode.nodeValue
+            href = l.get("id")
             hrefList.append(href)
+            # WTF: what does this do?
             myList = ",".join(hrefList)
             #logging.debug("getALLGisPlaces :%s"%(myList))
         return myList
           
+    def processPageInfo(self, dom, docinfo, pageinfo):
+        """processes page info divs from dom and stores in docinfo and pageinfo"""
+        # assume first second level div is pageMeta
+        alldivs = dom.find("div")
+        
+        if alldivs is None or alldivs.get('class', '') != 'pageMeta':
+            logging.error("processPageInfo: pageMeta div not found!")
+            return
+        
+        for div in alldivs:
+            dc = div.get('class')
+            
+            # pageNumberOrig  
+            if dc == 'pageNumberOrig':
+                pageinfo['pageNumberOrig'] = div.text
+                
+            # pageNumberOrigNorm
+            elif dc == 'pageNumberOrigNorm':
+                pageinfo['pageNumberOrigNorm'] = div.text
+                
+            # pageHeaderTitle
+            elif dc == 'pageHeaderTitle':
+                pageinfo['pageHeaderTitle'] = div.text
+                
+            # numFigureEntries
+            elif dc == 'countFigureEntries':
+                docinfo['numFigureEntries'] = getInt(div.text)
+                
+            # numTocEntries
+            elif dc == 'countTocEntries':
+                # WTF: s1 = int(s)/30+1
+                docinfo['numTocEntries'] = getInt(div.text)
+                
+            # numPlaces
+            elif dc == 'countPlaces':
+                docinfo['numPlaces'] = getInt(div.text)
+                
+            # numTextPages
+            elif dc == 'countPages':
+                np = getInt(div.text)                    
+                if np > 0:
+                    docinfo['numTextPages'] = np
+                    if docinfo.get('numPages', 0) == 0:
+                        # seems to be text-only - update page count
+                        docinfo['numPages'] = np
+                        #pageinfo['end'] = min(pageinfo['end'], np)
+                        pageinfo['numgroups'] = int(np / pageinfo['groupsize'])
+                        if np % pageinfo['groupsize'] > 0:
+                            pageinfo['numgroups'] += 1
+        
+        #logging.debug("processPageInfo: pageinfo=%s"%repr(pageinfo))
+        return
+         
            
-    def getTextPage(self, mode="text_dict", pn=1, docinfo=None, pageinfo=None):
+    def getTextPage(self, mode="text", pn=1, docinfo=None, pageinfo=None):
         """returns single page from fulltext"""
+        logging.debug("getTextPage mode=%s, pn=%s"%(mode,pn))
+        # check for cached text -- but ideally this shouldn't be called twice
+        if pageinfo.has_key('textPage'):
+            logging.debug("getTextPage: using cached text")
+            return pageinfo['textPage']
+        
         docpath = docinfo['textURLPath']
-        path = docinfo['textURLPath']
-        url = docinfo.get('url',None)
-        name = docinfo.get('name',None)
-        pn =pageinfo['current']
-        #sn = pageinfo['sn']
-        s = pageinfo['s']
-        highlightElementPos =pageinfo ['highlightElementPos']
-        highlightElement = pageinfo ['highlightElement']
-        #optionToggle =pageinfo ['optionToggle']
-        highlightQuery = pageinfo['highlightQuery']
-        #mode = pageinfo ['viewMode']
-        tocMode = pageinfo['tocMode']
-        xpointer = pageinfo['xpointer']
-        characterNormalization=pageinfo['characterNormalization']
-        tocPN = pageinfo['tocPN']
-        selfurl = self.absolute_url()   
-        
-        if mode == "text_dict":
+        # just checking
+        if pageinfo['current'] != pn:
+            logging.warning("getTextPage: current!=pn!")
+            
+        # stuff for constructing full urls
+        url = docinfo['url']
+        urlmode = docinfo['mode']
+        sn = pageinfo.get('sn', None)
+        highlightQuery = pageinfo.get('highlightQuery', None)
+        tocMode = pageinfo.get('tocMode', None)
+        tocPN = pageinfo.get('tocPN',None)
+        characterNormalization = pageinfo.get('characterNormalization', None)
+        
+        selfurl = docinfo['viewerUrl']
+        
+        if mode == "dict" or mode == "text_dict":
+            # dict is called textPollux in the backend
             textmode = "textPollux"
+        elif not mode:
+            # default is text
+            mode = "text"
+            textmode = "text"
         else:
             textmode = mode
         
-        textParam = "document=%s&mode=%s&pn=%s&characterNormalization=%s&xpointer=%s&options=withIdentifier"%(docpath,textmode,pn,characterNormalization, xpointer)
-        if highlightQuery is not None:
-            #textParam +="&highlightQuery=%s&sn=%s"%(urllib.quote(highlightQuery),sn)
-            textParam +="&highlightQuery=%s&s=%s&highlightElement=%s&highlightElementPos=%s"%(urllib.quote(highlightQuery),s, highlightElement, highlightElementPos)           
-        
+        textParam = "document=%s&mode=%s&pn=%s&characterNormalization=%s"%(docpath,textmode,pn,characterNormalization)
+        if highlightQuery:
+            textParam +="&highlightQuery=%s&sn=%s"%(urllib.quote(highlightQuery),sn)           
+        
+        # fetch the page
         pagexml = self.getServerData("page-fragment.xql",textParam)
-        dom = Parse(pagexml)
-        #dom = NonvalidatingReader.parseStream(pagexml)
-        
-        #original Pages
-        pagedivs = dom.xpath("//div[@class='pageNumberOrig']")       
-        
-        """if pagedivs == dom.xpath("//div[@class='pageNumberOrig']"):
-            if len(pagedivs)>0:
-                docinfo['pageNumberOrig']= getTextFromNode(pagedivs[0])
-                logging.debug("ORIGINAL PAGE: %s"%(docinfo['pageNumberOrig']))
-        
-        #original Pages Norm
-        pagedivs = dom.xpath("//div[@class='pageNumberOrigNorm']")
-        if pagedivs == dom.xpath("//div[@class='pageNumberOrigNorm']"):
-            if len(pagedivs)>0:
-                docinfo['pageNumberOrigNorm']= getTextFromNode(pagedivs[0])
-                logging.debug("ORIGINAL PAGE NORM: %s"%(docinfo['pageNumberOrigNorm']))
-        """
-        #figureEntries
-        pagedivs = dom.xpath("//div[@class='countFigureEntries']")
-        if pagedivs == dom.xpath("//div[@class='countFigureEntries']"):
-            if len(pagedivs)>0:
-                docinfo['countFigureEntries'] = getTextFromNode(pagedivs[0])
-                s = getTextFromNode(pagedivs[0])
-                if s=='0':
-                    try:
-                        docinfo['countFigureEntries'] = int(s)
-                    except:
-                        docinfo['countFigureEntries'] = 0
-                else:
-                    s1 = int(s)/30+1
-                    try:
-                        docinfo['countFigureEntries'] = int(s1)
-                    except:
-                        docinfo['countFigureEntries'] = 0      
-        
-        #allPlaces
-        pagedivs = dom.xpath("//div[@class='countPlaces']")
-        if pagedivs == dom.xpath("//div[@class='countPlaces']"):
-            if len(pagedivs)>0:
-                docinfo['countPlaces']= getTextFromNode(pagedivs[0])
-                s = getTextFromNode(pagedivs[0])
-                try:
-                    docinfo['countPlaces'] = int(s)
-                except:
-                    docinfo['countPlaces'] = 0
-        
-        #tocEntries
-        pagedivs = dom.xpath("//div[@class='countTocEntries']")
-        if pagedivs == dom.xpath("//div[@class='countTocEntries']"):
-            if len(pagedivs)>0:
-                docinfo['countTocEntries'] = int(getTextFromNode(pagedivs[0]))
-                s = getTextFromNode(pagedivs[0])
-                if s=='0':
-                    try:
-                        docinfo['countTocEntries'] = int(s)
-                    except:
-                        docinfo['countTocEntries'] = 0
-                else:
-                    s1 = int(s)/30+1
-                    try:
-                        docinfo['countTocEntries'] = int(s1)
-                    except:
-                        docinfo['countTocEntries'] = 0
-        
-        #numTextPages
-        pagedivs = dom.xpath("//div[@class='countPages']")
-        if pagedivs == dom.xpath("//div[@class='countPages']"):
-            if len(pagedivs)>0:
-                docinfo['numPages'] = getTextFromNode(pagedivs[0])
-                s = getTextFromNode(pagedivs[0])
-                
-                try:
-                    docinfo['numPages'] = int(s)
-                    #logging.debug("PAGE NUMBER: %s"%(s))
-                
-                    np = docinfo['numPages']
-                    pageinfo['end'] = min(pageinfo['end'], np)
-                    pageinfo['numgroups'] = int(np / pageinfo['groupsize'])
-                    if np % pageinfo['groupsize'] > 0:
-                        pageinfo['numgroups'] += 1                
-                except:
-                    docinfo['numPages'] = 0
-                  
-        else:
-         #no full text -- init to 0
-            docinfo['pageNumberOrig'] = 0
-            docinfo['countFigureEntries'] = 0
-            docinfo['countPlaces'] = 0
-            docinfo['countTocEntries'] = 0
-            docinfo['numPages'] = 0
-            docinfo['pageNumberOrigNorm'] = 0
-        #return docinfo
+        dom = ET.fromstring(pagexml)
+        # extract additional info
+        self.processPageInfo(dom, docinfo, pageinfo)
+        # page content is in <div class="pageContent">
+        pagediv = None
+        # ElementTree 1.2 in Python 2.6 can't do div[@class='pageContent']
+        # so we look at the second level divs
+        alldivs = dom.findall("div")
+        for div in alldivs:
+            dc = div.get('class')
+            # page content div
+            if dc == 'pageContent':
+                pagediv = div
+                break
         
         # plain text mode
         if mode == "text":
-            # first div contains text
-            pagedivs = dom.xpath("/div")
-            if len(pagedivs) > 0:      
-                pagenode = pagedivs[0]
-                links = pagenode.xpath("//a")
+            # get full url assuming documentViewer is parent
+            selfurl = self.getLink()
+            if pagediv is not None:
+                links = pagediv.findall(".//a")
                 for l in links:
-                    hrefNode = l.getAttributeNodeNS(None, u"href")
-                    if hrefNode:
-                        href= hrefNode.nodeValue
-                        if href.startswith('#note-'):
-                            hrefNode.nodeValue = href.replace('#note-',"?url=%s&viewMode=text&tocMode=%s&tocPN=%s&pn=%s#note-"%(url,tocMode,tocPN,pn))
-                        #if href.startswith():
-                return serializeNode(pagenode)
-        if mode == "xml":
-              # first div contains text
-              pagedivs = dom.xpath("/div")
-              if len(pagedivs) > 0:
-                  pagenode = pagedivs[0]
-                  return serializeNode(pagenode)
-        if mode == "gis":
-              # first div contains text
-              pagedivs = dom.xpath("/div")
-              if len(pagedivs) > 0:
-                  pagenode = pagedivs[0]
-                  links =pagenode.xpath("//a")
-                  for l in links:
-                      hrefNode =l.getAttributeNodeNS(None, u"href")
-                      if hrefNode:
-                          href=hrefNode.nodeValue
-                          if href.startswith('http://mappit.mpiwg-berlin.mpg.de'):
-                              hrefNode.nodeValue =href.replace('db/REST/db/chgis/mpdl','db/RESTdb/db/mpdl/%s'%name)
-                              l.setAttributeNS(None, 'target', '_blank') 
-                  return serializeNode(pagenode)
+                    href = l.get('href')
+                    if href and href.startswith('#note-'):
+                        href = href.replace('#note-',"%s#note-"%selfurl)
+                        l.set('href', href)
+
+                return serialize(pagediv)
+            
+        # text-with-links mode
+        elif mode == "dict":
+            if pagediv is not None:
+                viewerurl = docinfo['viewerUrl']
+                selfurl = self.getLink()
+                # check all a-tags
+                links = pagediv.findall(".//a")
+                for l in links:
+                    href = l.get('href')
                     
-        if mode == "pureXml":
-              # first div contains text
-              pagedivs = dom.xpath("/div")
-              if len(pagedivs) > 0:
-                  pagenode = pagedivs[0]
-                  return serializeNode(pagenode)      
-        # text-with-links mode
-        if mode == "text_dict":
-            # first div contains text
-            #mode = pageinfo ['viewMode']
-            pagedivs = dom.xpath("/div")
-            if len(pagedivs) > 0:
-                pagenode = pagedivs[0]
-                # check all a-tags
-                links = pagenode.xpath("//a")
-                
-                for l in links:
-                    hrefNode = l.getAttributeNodeNS(None, u"href")
-                    
-                    if hrefNode:
+                    if href:
                         # is link with href
-                        href = hrefNode.nodeValue
-                        if href.startswith('http://mpdl-text.mpiwg-berlin.mpg.de/mpdl/interface/lt/wordInfo.xql'):
-                            # is pollux link
+                        if href.startswith('http://mpdl-proto.mpiwg-berlin.mpg.de/mpdl/interface/lt/wordInfo.xql'):
+                            # is dictionary link - change href (keeping parameters)
+                            l.set('href', href.replace('http://mpdl-proto.mpiwg-berlin.mpg.de/mpdl/interface/lt/wordInfo.xql','%s/template/viewer_wordinfo'%viewerurl))
+                            # add target to open new page
+                            l.set('target', '_blank')
+                                                          
+                        # TODO: is this needed?
+                        if href.startswith('http://mpdl-proto.mpiwg-berlin.mpg.de/mpdl/lt/lemma.xql'):
                             selfurl = self.absolute_url()
-                            # change href
-                            hrefNode.nodeValue = href.replace('http://mpdl-text.mpiwg-berlin.mpg.de/mpdl/interface/lt/wordInfo.xql','%s/head_main_voc'%selfurl)
-                            # add target
-                            l.setAttributeNS(None, 'target', '_blank')
-                            #l.setAttributeNS(None, 'onclick',"popupWin = window.open(this.href, 'InfoWindow', 'menubar=no, location,width=500,height=600,top=180, left=700, toolbar=no, scrollbars=1'); return false;")
-                            #l.setAttributeNS(None, "ondblclick", "popupWin.focus();")
-                            #window.open("this.href, 'InfoWindow', 'menubar=no, location,width=500,height=600,top=180, left=700, toolbar=yes, scrollbars=1'"); return false;") 
-                                                          
-                        if href.startswith('http://mpdl-text.mpiwg-berlin.mpg.de/mpdl/lt/lemma.xql'):    
-                            selfurl = self.absolute_url()
-                            hrefNode.nodeValue = href.replace('http://mpdl-text.mpiwg-berlin.mpg.de/mpdl/lt/lemma.xql','%s/head_main_lemma'%selfurl)
-                            l.setAttributeNS(None, 'target', '_blank')
-                            l.setAttributeNS(None, 'onclick',"popupWin = window.open(this.href, 'InfoWindow', 'menubar=no, location,width=300,height=400,top=180, left=700, toolbar=no, scrollbars=1'); return false;")
-                            l.setAttributeNS(None, 'ondblclick', 'popupWin.focus();')   
+                            l.set('href', href.replace('http://mpdl-proto.mpiwg-berlin.mpg.de/mpdl/lt/lemma.xql','%s/head_main_lemma'%selfurl))
+                            l.set('target', '_blank')
+                            l.set('onclick',"popupWin = window.open(this.href, 'InfoWindow', 'menubar=no, location,width=500,height=600,top=180, left=700, toolbar=no, scrollbars=1'); return false;")
+                            l.set('ondblclick', 'popupWin.focus();')   
                     
                         if href.startswith('#note-'):
-                            hrefNode.nodeValue = href.replace('#note-',"?url=%s&viewMode=text_dict&tocMode=%s&tocPN=%s&pn=%s#note-"%(url,tocMode,tocPN,pn))  
+                            # note link
+                            l.set('href', href.replace('#note-',"%s#note-"%selfurl))
                               
-                return serializeNode(pagenode)
+                return serialize(pagediv)
+            
+        # xml mode
+        elif mode == "xml":
+            if pagediv is not None:
+                return serialize(pagediv)
+            
+        # pureXml mode
+        elif mode == "pureXml":
+            if pagediv is not None:
+                return serialize(pagediv)
+                  
+        # gis mode
+        elif mode == "gis":
+            name = docinfo['name']
+            if pagediv is not None:
+                # check all a-tags
+                links = pagediv.findall(".//a")
+                for l in links:
+                    href = l.get('href')
+                    if href:
+                        if href.startswith('http://chinagis.mpiwg-berlin.mpg.de'):
+                            l.set('href', href.replace('chinagis_REST/REST/db/chgis/mpdl','chinagis/REST/db/mpdl/%s'%name))
+                            l.set('target', '_blank') 
+                            
+                return serialize(pagediv)
+                    
         return "no text here"
     
-    def getOrigPages(self, docinfo=None, pageinfo=None):
-        docpath = docinfo['textURLPath']
-        pn =pageinfo['current']
-        selfurl = self.absolute_url()   
-        pagexml = self.getServerData("page-fragment.xql","document=%s&pn=%s"%(docpath, pn))
-        dom = Parse(pagexml)
-        pagedivs = dom.xpath("//div[@class='pageNumberOrig']")
-        if pagedivs == dom.xpath("//div[@class='pageNumberOrig']"):
-            if len(pagedivs)>0:
-                docinfo['pageNumberOrig']= getTextFromNode(pagedivs[0])        
-                return docinfo['pageNumberOrig']
-    
-    def getOrigPagesNorm(self, docinfo=None, pageinfo=None):
-        docpath = docinfo['textURLPath']
-        pn =pageinfo['current']
-        selfurl = self.absolute_url()   
-        pagexml = self.getServerData("page-fragment.xql","document=%s&pn=%s"%(docpath, pn))
-        dom = Parse(pagexml)
-        pagedivs = dom.xpath("//div[@class='pageNumberOrigNorm']")
-        if pagedivs == dom.xpath("//div[@class='pageNumberOrigNorm']"):
-            if len(pagedivs)>0:
-                docinfo['pageNumberOrigNorm']= getTextFromNode(pagedivs[0])        
-                return docinfo['pageNumberOrigNorm']
-
-                
-    def getTranslate(self, word=None, language=None, display=None):
-        """translate into another languages"""
-        data = self.getServerData("lt/wordInfo.xql","language="+str(language)+"&word="+urllib.quote(word)+"&display="+urllib.quote(display)+"&output=html")
-        #pagexml=self.template.fulltextclient.eval("/mpdl/interface/lt/lex.xql","document=&language="+str(language)+"&query="+url_quote(str(query)))
+    # TODO: should be getWordInfo
+    def getWordInfo(self, word='', language='', display=''):
+        """show information (like dictionaries) about word"""
+        data = self.getServerData("lt/wordInfo.xql","language=%s&word=%s&display=%s&output=html"%(language,urllib.quote(word),urllib.quote(display)))
         return data
     
+    # WTF: what does this do?
     def getLemma(self, lemma=None, language=None):
         """simular words lemma """
@@ -427,4 +407,5 @@
         return data
     
+    # WTF: what does this do?
     def getLemmaQuery(self, query=None, language=None):
         """simular words lemma """
@@ -432,9 +413,11 @@
         return data
     
+    # WTF: what does this do?
     def getLex(self, query=None, language=None):
         #simular words lemma
         data = self.getServerData("lt/lex.xql","document=&language="+str(language)+"&query="+urllib.quote(query))
         return data
-    
+
+    # WTF: what does this do?
     def getQuery (self,  docinfo=None, pageinfo=None, query=None, queryType=None, pn=1):
          #number of
@@ -455,7 +438,9 @@
     
     def getToc(self, mode="text", docinfo=None):
-        """loads table of contents and stores in docinfo"""
+        """loads table of contents and stores XML in docinfo"""
+        logging.debug("getToc mode=%s"%mode)
         if mode == "none":
-            return docinfo        
+            return docinfo
+              
         if 'tocSize_%s'%mode in docinfo:
             # cached toc
